<?xml version="1.0" encoding="UTF-8" standalone="no"?>
<project xmlns="http://maven.apache.org/POM/4.0.0" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xsi:schemaLocation="http://maven.apache.org/POM/4.0.0 http://maven.apache.org/xsd/maven-4.0.0.xsd">
  	
  <modelVersion>4.0.0</modelVersion>
  	
  <groupId>org.josast</groupId>
  	
  <artifactId>JOSAST-parent</artifactId>
  	
  <version>0.0.2-SNAPSHOT</version>
  	
  <packaging>pom</packaging>
  	
  <name>josast Parent</name>
  	
  <url>https://code.electrolab.fr/xtof/josast</url>
  	
  	
  <organization>
    <name>Amsat-Francophone</name>
    <url>http://www.amsat-f.org</url>
  </organization>
  	  <licenses>
    <license>
      <name>GNU LESSER GENERAL PUBLIC LICENSE 2.1</name>
      <url>https://www.gnu.org/licenses/old-licenses/gpl-2.0.fr.html</url>
      <comments> </comments>
      <distribution> </distribution>
    </license>
  </licenses>

  <developers> 
   <developer>
      <name>Christophe Mercier</name>
      <id>Christophe</id>
      <email>christophe.mcr+josast@gmail.com</email>
      <timezone>+1</timezone>
      <organization>Amsat-Francophone</organization>
      <organizationUrl>http://www.amsat-f.org</organizationUrl>
      <roles>
        <role>Tech lead</role>
        <role>développeur</role>
      </roles>
    </developer>
    </developers>
    
    <properties>
    <project.build.sourceEncoding>UTF-8</project.build.sourceEncoding>
    		
    <maven.compiler.source>1.8</maven.compiler.source>
    		
    <maven.compiler.target>1.8</maven.compiler.target>
    		
    <java.16.home>C:\Program Files\Java\jdk1.8.0_181\bin</java.16.home>
    		
    <!-- Plugin versions -->
    		
    <plugin.maven-assembly.version>3.2.0  </plugin.maven-assembly.version>
    		
    <plugin.checkstyle.version>3.1.0</plugin.checkstyle.version>
    		
    <plugin.maven-resources.version>3.1.0 </plugin.maven-resources.version>
    		
    <plugin.project-info-reports.version>2.9</plugin.project-info-reports.version>
    		
    <plugin.compiler.version>3.8.1</plugin.compiler.version>
    		
    <plugin.dependency.version>3.1.2</plugin.dependency.version>
    		
    <plugin.deploy.version>3.0.0-M1</plugin.deploy.version>
    		
   
    		
    <plugin.javadoc.version>3.2.0</plugin.javadoc.version>
    		
    <plugin.pmd-plugin.version>3.13.0</plugin.pmd-plugin.version>
    		
    <plugin.release.version>3.0.0-M1</plugin.release.version>
    		
    <plugin.site.version>3.9.0</plugin.site.version>
    		
    <plugin.maven-changelog.version>2.3</plugin.maven-changelog.version>
    		
    <plugin.maven-clean-plugin.verson>3.1.0 </plugin.maven-clean-plugin.verson>
    		
    <plugin.source.version>3.2.1</plugin.source.version>
    		
    <plugin.surefire.version>3.0.0-M4</plugin.surefire.version>
    		
    <plugin.failsafe.version>3.0.0-M4</plugin.failsafe.version>
    		
    <plugin.wagon-ssh.version>3.0.0</plugin.wagon-ssh.version>
    		
    <plugin.versions-maven.version>2.7</plugin.versions-maven.version>
    		
    <plugin.maven-jar-plugin.version>3.2.0 </plugin.maven-jar-plugin.version>
    		
    <plugin.taglist-maven-plugin>2.4   </plugin.taglist-maven-plugin>
    		
    <jacoco-maven-plugin.version>0.8.5 </jacoco-maven-plugin.version>
    		
    <maven-jetty-plugin.version> 6.1.26</maven-jetty-plugin.version>
    		
    <maven-checkstyle-plugin.configLocation>${project.basedir}/code-analysis/checkstyle.xml</maven-checkstyle-plugin.configLocation>
    		
    <maven-pmd-plugin.configLocation>${project.basedir}/../code-analysis/pmd.xml</maven-pmd-plugin.configLocation>
    		
    <checkstyle.skip>false</checkstyle.skip>
    		
   
    		
    <javadocs.skip>false</javadocs.skip>
    		
    <pmd.skip>false</pmd.skip>
    		
    <!--  librairie version  -->
    		
    <junit.version>3.8.2</junit.version>
    		
    <log4j.version>1.2.17</log4j.version>
    	
  </properties>
  	
  <dependencies>
    		
    <dependency>
      			
      <groupId>junit</groupId>
      			
      <artifactId>junit</artifactId>
      			
      <version>${junit.version}</version>
      			
      <scope>test</scope>
      		
    </dependency>
    		
    <!-- https://mvnrepository.com/artifact/log4j/log4j -->
    		
    <dependency>
      			
      <groupId>log4j</groupId>
      			
      <artifactId>log4j</artifactId>
      			
      <version>${log4j.version}</version>
      		
    </dependency>
    	
  </dependencies>
  	
  <reporting>
  
  <plugins>
            <plugin>
                <groupId>com.github.spotbugs</groupId>
                <artifactId>spotbugs-maven-plugin</artifactId>
                <version>4.0.0</version>
            </plugin>
  
      
      <plugin>
              <groupId>org.owasp</groupId>
              <artifactId>dependency-check-maven</artifactId>
              <version>5.3.2</version>
                <reportSets>
                    <reportSet>
                        <reports>
                            <report>aggregate</report>
                        </reports>
                    </reportSet>
                </reportSets>
            </plugin>
       <plugin>
        <groupId>org.apache.maven.plugins</groupId>
        				
        <artifactId>maven-project-info-reports-plugin</artifactId>
        				
        <version>${plugin.project-info-reports.version}</version>
        			
      </plugin>
      			
      <plugin>
        				
        <groupId>org.apache.maven.plugins</groupId>
        				
        <artifactId>maven-pmd-plugin</artifactId>
        				
        <version>${plugin.pmd-plugin.version}</version>
        			
      </plugin>
      			
      
      			
      <plugin>
        				
        <groupId>org.apache.maven.plugins</groupId>
        				
        <artifactId>maven-checkstyle-plugin</artifactId>
        				
        <version>${plugin.checkstyle.version}</version>
        				
        <reportSets>
          					
          <!-- reportSet ex?cut? dans tous les modules -->
          					
          <reportSet>
            						
            <reports>
              							
              <report>checkstyle</report>
              						
            </reports>
            					
          </reportSet>
          					
          <!-- reportSet d'agr?gation des rapports des sous-modules -->
          					
          <reportSet>
            						
            <id>checkstyle-aggregate</id>
            						
            <inherited>false</inherited>
            						
            <configuration>
              							
              <skipExec>true</skipExec>
              						
            </configuration>
            						
            <reports>
              							
              <report>checkstyle-aggregate</report>
              						
            </reports>
            					
          </reportSet>
          				
        </reportSets>
        			
      </plugin>
      			
      <plugin>
        				
        <groupId>org.codehaus.mojo</groupId>
        				
        <artifactId>versions-maven-plugin</artifactId>
        				
        <version>${plugin.versions-maven.version}</version>
        			
      </plugin>
      		
    </plugins>
    	
  </reporting>
  	
  <build>
    		
    <pluginManagement>
      			
      <plugins>
        				
   
        <plugin>
          					
          <groupId>org.apache.maven.plugins</groupId>
          					
          <artifactId>maven-project-info-reports-plugin</artifactId>
          					
          <!-- <version>${plugin.project-info-reports.version}</version> -->
          				
        </plugin>
        				
        <!-- TO BE CONFIGURE WITH SCM -->
        				
        <plugin>
          					
          <groupId>org.apache.maven.plugins</groupId>
          					
          <artifactId>maven-changelog-plugin</artifactId>
          					
          <version>${plugin.maven-changelog.version}</version>
          				
        </plugin>
        				
        <plugin>
          					
          <groupId>org.apache.maven.plugins</groupId>
          					
          <artifactId>maven-assembly-plugin</artifactId>
          					
          <version>${plugin.maven-assembly.version}</version>
          				
        </plugin>
        				
        <plugin>
          					
          <groupId>org.apache.maven.plugins</groupId>
          					
          <artifactId>maven-resources-plugin</artifactId>
          					
          <version>${plugin.maven-resources.version}</version>
          					
          <configuration>
            						
            <encoding>UTF-8</encoding>
            					
          </configuration>
          				
        </plugin>
        				
        <!-- A revoir -->
        				
        <plugin>
          					
          <groupId>org.apache.maven.plugins</groupId>
          					
          <artifactId>maven-jar-plugin</artifactId>
          					
          <version>${plugin.maven-jar-plugin.version}</version>
          				
        </plugin>
        				
        <plugin>
          					
          <groupId>org.apache.maven.plugins</groupId>
          					
          <artifactId>maven-source-plugin</artifactId>
          					
          <version>${plugin.source.version}</version>
          				
        </plugin>
        				
        <plugin>
          					
          <groupId>org.apache.maven.plugins</groupId>
          					
          <artifactId>maven-compiler-plugin</artifactId>
          					
          <version>${plugin.compiler.version}</version>
          				
        </plugin>
        				
        <plugin>
          					
          <groupId>org.apache.maven.plugins</groupId>
          					
          <artifactId>maven-surefire-plugin</artifactId>
          					
          <version>${plugin.surefire.version}</version>
          				
        </plugin>
        				
        <plugin>
          					
          <groupId>org.apache.maven.plugins</groupId>
          					
          <artifactId>maven-failsafe-plugin</artifactId>
          					
          <version>${plugin.failsafe.version}</version>
          				
        </plugin>
        				
        <plugin>
          					
          <groupId>org.apache.maven.plugins</groupId>
          					
          <artifactId>maven-pmd-plugin</artifactId>
          					
          <version>${plugin.pmd-plugin.version}</version>
          				
        </plugin>
        				
        <plugin>
          					
          <groupId>org.apache.maven.plugins</groupId>
          					
          <artifactId>maven-javadoc-plugin</artifactId>
          					
          <version>${plugin.javadoc.version}</version>
          				
        </plugin>
        				
        <plugin>
          					
          <groupId>org.codehaus.mojo</groupId>
          					
          <artifactId>versions-maven-plugin</artifactId>
          					
          <version>${plugin.versions-maven.version}</version>
          				
        </plugin>
        				
        				
        <plugin>
          					
          <groupId>org.codehaus.mojo</groupId>
          					
          <artifactId>taglist-maven-plugin</artifactId>
          					
          <version>${plugin.taglist-maven-plugin}</version>
          				
        </plugin>
        				
        <plugin>
          					
          <groupId>org.apache.maven.plugins</groupId>
          					
          <artifactId>maven-release-plugin</artifactId>
          					
          <version>${plugin.release.version}</version>
          				
        </plugin>
        				
        <plugin>
          					
          <groupId>org.apache.maven.plugins</groupId>
          					
          <artifactId>maven-dependency-plugin</artifactId>
          					
          <version>${plugin.dependency.version}</version>
          				
        </plugin>
        				
        <plugin>
          					
          <groupId>org.apache.maven.plugins</groupId>
          					
          <artifactId>maven-deploy-plugin</artifactId>
          					
          <version>${plugin.deploy.version}</version>
          				
        </plugin>
        				        
        <plugin>
                    
          <artifactId>maven-clean-plugin</artifactId>
                    
          <version>${plugin.maven-clean-plugin.verson}</version>
                  
        </plugin>
        			
      </plugins>
      		
    </pluginManagement>
    		
    <plugins>
      			
      <plugin>
        				
        <groupId>org.jacoco</groupId>
        				
        <artifactId>jacoco-maven-plugin</artifactId>
        				
        <version>${jacoco-maven-plugin.version} </version>
        				
        <executions>
          					
          <execution>
            						
            <goals>
              							
              <goal>prepare-agent</goal>
              						
            </goals>
            					
          </execution>
          					
          <!-- attached to Maven test phase -->
          					
          <execution>
            						
            <id>report</id>
            						
            <phase>test</phase>
            						
            <goals>
              							
              <goal>report</goal>
              						
            </goals>
            					
          </execution>
          				
        </executions>
        			
      </plugin>
      			
      <plugin>
        				
        <groupId>org.apache.maven.plugins</groupId>
        				
        <artifactId>maven-source-plugin</artifactId>
        				
        <configuration>
          					
          <attach>true</attach>
          				
        </configuration>
        				
        <executions>
          					
          <execution>
            						
            <id>generate-sources</id>
            						
            <phase>verify</phase>
            						
            <goals>
              							
              <goal>jar-no-fork</goal>
              						
            </goals>
            					
          </execution>
          				
        </executions>
        			
      </plugin>
      			
      <plugin>
        				
        <groupId>org.apache.maven.plugins</groupId>
        				
        <artifactId>maven-site-plugin</artifactId>
        				
        <version>${plugin.site.version}</version>
        			
      </plugin>
      			
      <plugin>
        				
        <groupId>org.apache.maven.plugins</groupId>
        				
        <artifactId>maven-project-info-reports-plugin</artifactId>
        				
        <version>${plugin.project-info-reports.version}</version>
        			
      </plugin>
      			
      <plugin>
        				
        <groupId>org.apache.maven.plugins</groupId>
        				
        <artifactId>maven-javadoc-plugin</artifactId>
        				
        <configuration>
          					
          <!-- Do not fail on any JavaDocs error -->
          					
          <failOnError>false</failOnError>
          					
          <skip>${javadocs.skip}</skip>
          				
        </configuration>
        			
      </plugin>
      			
      <plugin>
        				
        <groupId>org.apache.maven.plugins</groupId>
        				
        <artifactId>maven-surefire-plugin</artifactId>
        				
        <configuration>
          					
          <!-- balanced,reversealphabetical,random,hourly,failedfirst,filesystem 
						(default) -->
          					
          <runOrder>alphabetical</runOrder>
          					
          <failIfNoTests>false</failIfNoTests>
          					
          <argLine>${surefire.jvm.args}</argLine>
          				
        </configuration>
        			
      </plugin>
      			
      <plugin>
        				
        <groupId>org.apache.maven.plugins</groupId>
        				
        <artifactId>maven-failsafe-plugin</artifactId>
        				
        <executions>
          					
          <execution>
            						
            <id>integration-test</id>
            						
            <goals>
              							
              <goal>integration-test</goal>
              						
            </goals>
            					
          </execution>
          					
          <execution>
            						
            <id>verify</id>
            						
            <goals>
              							
              <goal>verify</goal>
              						
            </goals>
            					
          </execution>
          				
        </executions>
        			
      </plugin>
      			
      <plugin>
        				
        <groupId>org.apache.maven.plugins</groupId>
        				
        <artifactId>maven-pmd-plugin</artifactId>
        				
        <configuration>
          					
          <skip>${pmd.skip}</skip>
          					
          <targetJdk>${maven.compiler.source}</targetJdk>
          					
          <sourceEncoding>${project.build.sourceEncoding}</sourceEncoding>
          					
          <!--<minimumTokens>100</minimumTokens> -->
          					
          <rulesets>
            						
            <!-- A rule set, that comes bundled with PMD -->
            						
            <ruleset>/category/java/bestpractices.xml</ruleset>
            						
            <!-- <ruleset>${maven-pmd-plugin.configLocation}</ruleset> -->
            					
          </rulesets>
          					
          <failOnViolation>false</failOnViolation>
          				
        </configuration>
        				
        <executions>
          					
          <execution>
            						
            <phase>verify</phase>
            						
            <goals>
              							
              <goal>check</goal>
              							
              <goal>cpd-check</goal>
              						
            </goals>
            					
          </execution>
          				
        </executions>
        			
      </plugin>
      			
      <plugin>
        				
        <groupId>org.mortbay.jetty</groupId>
        				
        <artifactId>maven-jetty-plugin</artifactId>
        				
        <version>${maven-jetty-plugin.version}</version>
        				
        <configuration>
          					
          <scanIntervalSeconds>5</scanIntervalSeconds>
          					
          <stopKey>foo</stopKey>
          					
          <stopPort>9999</stopPort>
          				
        </configuration>
        			
      </plugin>
      		
    </plugins>
    	
  </build>
  
   <!-- =============================================================== -->
    <!-- DistributionManagement  TO BE DEFINED-->
    <!-- =============================================================== -->
    <distributionManagement>
        <site>
            <id>site-projet</id>
            <url>scp://exemple.org/www/</url>
        </site>
    </distributionManagement>
  	
  <modules>
    		
    <module>ModuleUtil</module>
    <module>ModuleSound</module>
    <module>ModuleConfig</module>
    <module>ModuleSoundModem</module>
    <module>ModuleSIDS</module>
    <module>ModuleEquationKepler</module>
<!--     <module>ModuleInflux</module> -->
    <module>ModuleJourJulien</module>
    <module>ModuleCubesatSim</module>
    <module>ModuleAmicalsat</module>
    <module>ModuleSatelliteDatabase</module>
    <module>ApplicationCubesatSim</module>
    <module>ApplicationAmicalsatCli</module>
    <module>ApplicationAmicalsat</module>
    <module>ApplicationSatelliteDatabaseCli</module>
      
  </modules>
  
</project>
